/*
 * constants.h
 *
 *  Created on: 13.02.2011
 *      Author: AndreR
 */

#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__

/////////////////////////////////////////////////
// Buffer Sizes
/////////////////////////////////////////////////

// WIFI
// for each WifiRobot (NRF24_MAX_BOT_ID+1=24)
#define WIFI_TX_SIZE 400
#define WIFI_RX_SIZE 200

// USART1 - USB
#define USART1_TX_SIZE 1000
#define USART1_RX_SIZE 300

// CONSOLE
#define CONSOLE_RX_SIZE 1000
#define CONSOLE_TX_SIZE 2000
#define CONSOLE_PRINT_SIZE 400

// VISION
// protoc allocator size for unpacking
#define VISION_ALLOC_BUF_SIZE 4096

// RST
// protoc allocator size for unpacking
#define RST_ALLOC_BUF_SIZE 4096

/////////////////////////////////////////////////
// IRQ Levels
/////////////////////////////////////////////////

// MII Data
#define IRQL_ETH_DATA 12

// MII IRQ (link change)
#define IRQL_ETH_LINK 15

// SPI
#define IRQL_SPI1 11	// WF2
#define IRQL_SPI3 11	// WF1

// USART1
#define IRQL_USART1 14	// Serial console

// TIM7 - nRF24 timer (WF1)
#define IRQL_NRF24_TIMER 10

// TIM4 - RST timer
#define IRQL_RST_TIMER 11

// Wifi IRQ line (WF1)
#define IRQL_WIFI 9

#endif
