/*
 * led.c
 *
 *  Created on: 30.10.2010
 *      Author: AndreR
 */

#include "led.h"

#include "util/init_hal.h"

typedef struct _LEDGlobal
{
	uint16_t state;
} LEDGlobal;

static LEDGlobal led;

void LEDInit()
{
	led.state = 0;

	GPIOInitData gpioInit;
	gpioInit.mode = GPIO_MODE_OUTPUT;
	gpioInit.ospeed = GPIO_OSPEED_F3_2MHZ;
	gpioInit.otype = GPIO_OTYPE_PUSH_PULL;
	gpioInit.pupd = GPIO_PUPD_NONE;
	GPIOInit(GPIOB, LED_GREEN, &gpioInit);
}

void LEDSet(uint16_t state)
{
	led.state = state;

	if(led.state & LED_GREEN)
		GPIOB->BRR = LED_GREEN;
	else
		GPIOB->BSRR = LED_GREEN;
}

void LEDMustOn(uint16_t on)
{
	LEDSet(led.state | on);
}

void LEDMustOff(uint16_t off)
{
	LEDSet(led.state & ~(off));
}

void LEDToggle(uint16_t toggle)
{
	LEDSet(led.state ^ toggle);
}

uint16_t LEDGetState()
{
	return led.state;
}
