/*
 * intercom.c
 *
 *  Created on: 18.11.2012
 *      Author: AndreR
 */

#include "intercom1.h"

#include "util/intercom.h"
#include "intercom_constants.h"
#include "hal/usart1.h"

static void txReady(void* pData)
{
	USART* pUSART = (USART*)pData;
	USARTStartTransfer(pUSART);
}

void Intercom1Init()
{
	IntercomMedium medium;
	medium.pRxFifo = &usart1.rxFifo;
	medium.pTxFifo = &usart1.txFifo;
	medium.txReady = &txReady;
	medium.pTxReadyData = &usart1;
	medium.reachableAddresses = INTERCOM_ADDRESS_MAIN | INTERCOM_ADDRESS_MEDIA | INTERCOM_ADDRESS_RIGHT | INTERCOM_ADDRESS_LEFT;

	IntercomInit(INTERCOM_ADDRESS_KD, 0);

	usart1.callback = &IntercomRxReady;
	usart1.pUserData = 0;
	IntercomAddMedium(medium);
}
