/*
 * kick.h
 *
 *  Created on: 21.05.2014
 *      Author: AndreR
 */

#ifndef KICK_H_
#define KICK_H_

#include "ch.h"
#include "util/config.h"
#include "commands.h"

#define KICKER_DEVICE_STRAIGHT	0
#define KICKER_DEVICE_CHIP		1

#define KICK_EVENT_QUEUE_SIZE 4

typedef struct PACKED _KickInternalConfig
{
	uint16_t irThreshold;
	uint32_t irFilterThreshold;
	float kickVoltageLimit; // ignore kick cmds below kickVoltageLimit*curVoltage
} KickInternalConfig;

typedef struct _KickGlobal
{
	uint16_t irDiff;
	uint32_t irFilterCounter;
	uint8_t interrupted;

	uint16_t state;

	KickInternalConfig config;
	ConfigFile* pConfigFile;

	struct _armed
	{
		uint8_t device;
		float time;
		float rpm;
	} armed;

	Mailbox eventQueue;
	msg_t eventQueueData[KICK_EVENT_QUEUE_SIZE];
} KickGlobal;

extern KickGlobal kick;

void	KickInit();
msg_t	KickTask(void* params);
void	KickFire(float duration, uint8_t device);
void	KickArmIr(float fireDuration, uint8_t device);
void	KickArmDribbler(float fireDuration, uint8_t device);
void	KickDisarm();
void	KickDischarge();
void	KickSetConfig(uint16_t irThreshold, uint32_t irFilterLimit);

#endif /* KICK_H_ */
