/*
 * constants.h
 *
 *  Created on: 13.02.2011
 *      Author: AndreR
 */

#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__

/////////////////////////////////////////////////
// Buffer Sizes
/////////////////////////////////////////////////

// NETWORK
#define NETWORK_TX_PROCESSING_SIZE	1000
#define NETWORK_RX_PROCESSING_SIZE	1000
#define NETWORK_PRINT_SIZE 100
#define NETWORK_RELIABLE_BUF_SIZE 400

// NRF24
#define NRF24_TX_SIZE 2048
#define NRF24_RX_SIZE 2048

// SPI
#define SPI1_FIFO_SIZE 1024
#define SPI1_DMA_SIZE 1024
#define SPI1_CB_SIZE 1024

#define SPI2_FIFO_SIZE 1024
#define SPI2_DMA_SIZE 1024
#define SPI2_CB_SIZE 1024

#define SPI3_FIFO_SIZE 1024
#define SPI3_DMA_SIZE 1024
#define SPI3_CB_SIZE 1024

// USART1 - USB
#define USART1_TX_SIZE 1000
#define USART1_RX_SIZE 300

// USART2 - KD
#define USART2_FIFO_SIZE 2048
#define USART2_MAX_PACKET_SIZE 512

// USART6 - Media
#define USART6_FIFO_SIZE 2048
#define USART6_MAX_PACKET_SIZE 512

// CONSOLE
#define CONSOLE_RX_SIZE 1000
#define CONSOLE_TX_SIZE 2000
#define CONSOLE_PRINT_SIZE 400

// USB
#define USB_TX_SIZE 200
#define USB_RX_SIZE 300

/////////////////////////////////////////////////
// IRQ Levels
/////////////////////////////////////////////////

// SPI
#define IRQL_SPI1 13	// NRF24
#define IRQL_SPI2 14	// GYR, ACC
#define IRQL_SPI3 14	// LEFT, RIGHT

// BUZZER
#define IRQL_BUZZER 15

// External Interrupts
#define IRQL_EXTI5_9 13
#define IRQL_EXTI10_15 10

// USART1
#define IRQL_USART1 14

// USART2
#define IRQL_USART2 14

// USART6
#define IRQL_USART6 14

// TIM7 - nRF24 timer
#define IRQL_NRF24_TIMER 10

// TIM9 - precision timer for controller
#define IRQL_CTRL_TIMER 12

#define IRQL_MOTOR_FAULT 14

#endif
