/*
 * ctrl_calibrate.h
 *
 *  Created on: 20.01.2015
 *      Author: AndreR
 */

#ifndef CTRL_CALIBRATE_H_
#define CTRL_CALIBRATE_H_

#include "../ctrl.h"

#include "util/piecewise_function.h"
#include "util/lag_element.h"

typedef struct _CtrlCalibrate
{
	PiecewiseFunction trajectory;
//	uint8_t trajectoryAxis;
	float trajectoryAngle;

	LagElementPT1 trajectoryLag;

	uint32_t tPlateauStart;
	uint32_t tPlateauEnd;
	uint8_t onPlateau;

	uint32_t tRuntime;	// [us]
	uint8_t active;

	float setpoint[4];
	arm_matrix_instance_f32 matSetpoint;

	float curWheel[4];
	arm_matrix_instance_f32 matCurMotor;

	float distance;
	float acceleration;
	float plateauVelocity;

	// calibration results
	float encAvg;	// [m/s] or [rad/s] on selected axis

	float encPosXYW[3];
	arm_matrix_instance_f32 matEncPosXYW;

	float encPos[4];
	arm_matrix_instance_f32 matEncPos;
	uint32_t lastEncTimes[4];
	float lastEncVel[4];

	float accVel;
	uint32_t lastAccTime;
	float lastAccVal;

	float accVelAvg;

	float gyrPos;
	uint32_t lastGyrTime;
	float lastGyrVal;

	float gyrAvg;

	float startPos[3];
	uint8_t startPosTaken;

	float endPos[3];

	float lastOrientation;
	int32_t turns;

	float localPos[3];
} CtrlCalibrate;

extern CtrlCalibrate ctrlCalibrate;
extern CtrlInstance ctrlCalibrateInstance;

void CtrlCalibrateMove(float angle, float distance, float acceleration);
void CtrlCalibratePrintResult(uint8_t network);

#endif /* CTRL_CALIBRATE_H_ */
