/*
 * ctrl_test_step.c
 *
 *  Created on: 16.04.2013
 *      Author: AndreR
 */

#include "ctrl_test_step.h"
#include "util/console.h"
#include "util/sys_time.h"
#include "util/network_print.h"

#include <string.h>

static void init();
static void controller(CtrlInput* pInput, CtrlOutput* pOutput);
static void stateEstimation(CtrlInput* pInput, const CtrlOutput* pOutput);

CtrlTestStep ctrlTestStep;
CtrlInstance ctrlTestStepInstance = {
	.pInit = &init,
	.pExit = 0,
	.pStateEstimationFunc = &stateEstimation,
	.pControllerFunc = &controller,
	.pInput = 0,
	.deltaT = 0.001f };

static void init()
{
	memset(&ctrlTestStep, 0, sizeof(CtrlTestStep));
}

static void stateEstimation(CtrlInput* pInput, const CtrlOutput* pOutput)
{
	(void)pInput;
	(void)pOutput;
}

static void controller(CtrlInput* pInput, CtrlOutput* pOutput)
{
	(void)pInput;

	pOutput->ctrlMode = MOT_CTRL_VOLTAGE;
	if(ctrlTestStep.sampleCounter == 0)
	{
		memset(pOutput->motorVoltage, 0, 4*sizeof(float));

		return;
	}

	--ctrlTestStep.sampleCounter;

	for(uint8_t i = 0; i < 4; i++)
	{
		pOutput->motorVoltage[i] = ctrlTestStep.stepOutput;
	}
}

void CtrlTestStepSet(float output)
{
	ctrlTestStep.stepOutput = output;
	ctrlTestStep.sampleCounter = 1000;
}
