/*
 * led.c
 *
 *  Created on: 30.10.2010
 *      Author: AndreR
 */

#include "led.h"

#include "util/init_hal.h"

typedef struct _LEDGlobal
{
	uint16_t state;
} LEDGlobal;

static LEDGlobal led;

void LEDInit()
{
	led.state = 0;

	GPIOInitData gpioInit;
	gpioInit.mode = GPIO_MODE_OUTPUT;
	gpioInit.ospeed = GPIO_OSPEED_F4_2MHZ;
	gpioInit.otype = GPIO_OTYPE_PUSH_PULL;
	gpioInit.pupd = GPIO_PUPD_NONE;
	GPIOInit(GPIOA, LED_GREEN | LED_RED, &gpioInit);
}

void LEDSet(uint16_t state)
{
	led.state = state;

	if(led.state & LED_GREEN)
		GPIOA->BSRRH = LED_GREEN;
	else
		GPIOA->BSRRL = LED_GREEN;

	if(led.state & LED_RED)
		GPIOA->BSRRH = LED_RED;
	else
		GPIOA->BSRRL = LED_RED;
}

void LEDMustOn(uint16_t on)
{
	LEDSet(led.state | on);
}

void LEDMustOff(uint16_t off)
{
	LEDSet(led.state & ~(off));
}

void LEDToggle(uint16_t toggle)
{
	LEDSet(led.state ^ toggle);
}

uint16_t LEDGetState()
{
	return led.state;
}
