/*
 * power.c
 *
 * Power control and overcurrent watchdog.
 *
 *  Created on: 25.10.2010
 *      Author: AndreR
 */

#include "power.h"

#include "util/init_hal.h"

#define POWER_5V_ENABLE (1 << 11)	// GPIOA

void PowerInit()
{
	GPIOInitData gpioInit;
	gpioInit.mode = GPIO_MODE_OUTPUT;
	gpioInit.otype = GPIO_OTYPE_PUSH_PULL;
	gpioInit.ospeed = GPIO_OSPEED_F4_2MHZ;
	gpioInit.pupd =  GPIO_PUPD_NONE;
	GPIOInit(GPIOA, POWER_5V_ENABLE, &gpioInit);
}

void PowerEnable5VSupply(uint8_t enable)
{
	if(enable)
		GPIOA->BSRRL = POWER_5V_ENABLE;
	else
		GPIOA->BSRRH = POWER_5V_ENABLE;
}

uint8_t PowerIs5VSupplyEnabled()
{
	if(GPIOA->ODR & POWER_5V_ENABLE)
		return 0;
	else
		return 1;
}
