/*
 * intercom.c
 *
 *  Created on: 18.11.2012
 *      Author: AndreR
 */

#include "intercom1.h"

#include "util/intercom.h"

#include "hal/usart2.h"
#include "hal/usart6.h"
#include "constants.h"
#include "intercom_constants.h"
#include "spi3.h"

static void txReady(void* pData)
{
	USART* pUSART = (USART*)pData;
	USARTStartTransfer(pUSART);
}

void Intercom1Init()
{
	IntercomMedium medium;

	IntercomInit(INTERCOM_ADDRESS_MAIN, 1);

	medium.pRxFifo = &usart6.rxFifo;
	medium.pTxFifo = &usart6.txFifo;
	medium.txReady = &txReady;
	medium.pTxReadyData = &usart6;
	medium.reachableAddresses = INTERCOM_ADDRESS_MEDIA;
	usart6.callback = &IntercomRxReady;
	usart6.pUserData = 0;
	IntercomAddMedium(medium);

	medium.pRxFifo = &usart2.rxFifo;
	medium.pTxFifo = &usart2.txFifo;
	medium.txReady = &txReady;
	medium.pTxReadyData = &usart2;
	medium.reachableAddresses = INTERCOM_ADDRESS_KD;
	usart2.callback = &IntercomRxReady;
	usart2.pUserData = 0;
	IntercomAddMedium(medium);

	medium.pRxFifo = &spi3.slave[0].rxFifo;
	medium.pTxFifo = &spi3.slave[0].txFifo;
	medium.txReady = 0;
	medium.pTxReadyData = 0;
	medium.reachableAddresses = INTERCOM_ADDRESS_LEFT;
	spi3.callback = &IntercomRxReady;
	spi3.pUserData = 0;
	IntercomAddMedium(medium);

	medium.pRxFifo = &spi3.slave[1].rxFifo;
	medium.pTxFifo = &spi3.slave[1].txFifo;
	medium.txReady = 0;
	medium.pTxReadyData = 0;
	medium.reachableAddresses = INTERCOM_ADDRESS_RIGHT;
	spi3.callback = &IntercomRxReady;
	spi3.pUserData = 0;
	IntercomAddMedium(medium);
}
