/*
 * motors.h
 *
 *  Created on: 02.02.2014
 *      Author: AndreR
 */

#ifndef MOTORS_H_
#define MOTORS_H_

#include "ch.h"
#include "intercom_constants.h"

#define MOTORS_EVENT_QUEUE_SIZE 5

typedef void(*MotorsUpdateCallback)(uint8_t);

typedef struct _Motors
{
	Mailbox eventQueue;
	msg_t eventQueueBuf[MOTORS_EVENT_QUEUE_SIZE];

	struct _mot
	{
		MotorSetpoint set;
		MotorFeedback cur;
	} mot[4];

	MotorsUpdateCallback updateCb;

	uint32_t lastMotRx[2];

	uint8_t ctrlMode;
} Motors;

extern Motors motors;

void MotorsInit();
msg_t MotorsTask(void* params);

#endif /* MOTORS_H_ */
