/*
 * skills.h
 *
 *  Created on: 24.06.2015
 *      Author: AndreR
 */

#ifndef SKILLS_H_
#define SKILLS_H_

#include "commands.h"
#include "ch.h"

#define SKILL_OUT_MODE_LOCAL_VEL		0
#define SKILL_OUT_MODE_GLOBAL_VEL		1
#define SKILL_OUT_MODE_GLOBAL_POS		2

typedef struct PACKED _SkillOutput
{
	float xyw[6];
	uint8_t mode;
	uint8_t updated;
} SkillOutput;

typedef void(*SkillInit)();
typedef void(*SkillFunction)(void* pData, SkillOutput* pOutput);
typedef void(*SkillExit)();

typedef struct _SkillInstance
{
	SkillInit pInit;
	SkillFunction pSkill;
	SkillExit pExit;
} SkillInstance;

typedef struct _SkillInstanceId
{
	uint8_t id;

	SkillInstance* pInstance;
} SkillInstanceId;

typedef struct _Skills
{
	SkillOutput output;

	struct
	{
		Mutex mutex;
		uint8_t skillId;
		uint8_t data[SYSTEM_MATCH_CTRL_USER_DATA_SIZE];
	} input;

	SkillInstanceId* pInstanceId;

	uint8_t numSkills;
} Skills;

extern Skills skills;

void SkillsInit();
void SkillsSetInput(uint8_t skillId, const uint8_t* pData);
void SkillsExecute();

#endif /* SKILLS_H_ */
