/*
 * skill_sine.c
 *
 *  Created on: 25.06.2015
 *      Author: AndreR
 */

#include "skill_sine.h"

#include "arm_math.h"
#include "util/sys_time.h"

static void sineInit();
static void sineRun(void* pData, SkillOutput* pOutput);

SkillInstance skillSine = { &sineInit, &sineRun, 0 };

static struct _SkillSine
{
	float tStart;
} sine;

static void sineInit()
{
	sine.tStart = SysTime();
}

static void sineRun(void* pData, SkillOutput* pOutput)
{
	SkillSineInput* pInput = (SkillSineInput*)pData;

	float tNow = SysTime()-sine.tStart;

	float val = arm_sin_f32(2.0f*M_PI*tNow*pInput->freq*0.001f);

	pOutput->xyw[0] = pInput->vel[0]*0.001f*val;
	pOutput->xyw[1] = pInput->vel[1]*0.001f*val;
	pOutput->xyw[2] = pInput->vel[2]*0.001f*val;
	pOutput->mode = SKILL_OUT_MODE_LOCAL_VEL;
	pOutput->updated = 1;
}
