/*
 * bg_com.c
 *
 *  Created on: 09.10.2014
 *      Author: AndreR
 */

#include "bg_com.h"

#include "DIALOG.h"
#include "TEXT.h"
#include "ids.h"
#include <stdio.h>

static struct _DesktopHandles
{
	WM_HWIN desktop;

	struct
	{
		WM_HWIN hClass;
		WM_HWIN hClassCode;
		WM_HWIN hManufacturer;
		WM_HWIN hProduct;
		WM_HWIN hSerial;
	} hcd;

	struct
	{
		WM_HWIN hFatSize;
		WM_HWIN hFreeSize;
		WM_HWIN hClusterSize;
	} msc;

	struct
	{
		WM_HWIN hFilename;
		WM_HWIN hSize;
		WM_HWIN hBytesIn;
		WM_HWIN hBytesOut;
	} log;
} handles;


static void cbDesktop(WM_MESSAGE* pMsg)
{
	switch(pMsg->MsgId)
	{
		case WM_NOTIFY_PARENT:
		{
			if(pMsg->Data.v == WM_NOTIFICATION_CLICKED && WM_GetId(pMsg->hWinSrc) == GUI_ID_BGCOM)
			{
				LogFileClose();
			}
		}
		break;
		default:
			WM_DefaultProc(pMsg);
	}
}

WM_HWIN BGComInit()
{
	handles.desktop = WINDOW_CreateEx(0, 34, 240, 241, WM_HBKWIN, 0, 0, 0, &cbDesktop);
	WINDOW_SetBkColor(handles.desktop, GUI_BLACK);

	TEXT_SetDefaultFont(&GUI_Font13_1);

	// HCD
	TEXT_CreateEx(5, 5, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "USB Device:");
	handles.hcd.hClass = TEXT_CreateEx(80, 5, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "dev");

	TEXT_CreateEx(180, 5, 50, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Class:");
	handles.hcd.hClassCode = TEXT_CreateEx(210, 5, 50, 15, handles.desktop, WM_CF_SHOW, 0, 0, "42");

	TEXT_CreateEx(5, 20, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Manufacturer:");
	handles.hcd.hManufacturer = TEXT_CreateEx(80, 20, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "?");

	TEXT_CreateEx(5, 35, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Product:");
	handles.hcd.hProduct = TEXT_CreateEx(80, 35, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "prod");

	TEXT_CreateEx(5, 50, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Serial:");
	handles.hcd.hSerial = TEXT_CreateEx(80, 50, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "012345");

	// MSC
	TEXT_CreateEx(5, 65, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "FAT Size:");
	handles.msc.hFatSize = TEXT_CreateEx(80, 65, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "42 MB");

	TEXT_CreateEx(5, 80, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Free:");
	handles.msc.hFreeSize = TEXT_CreateEx(80, 80, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "43 MB");

	TEXT_CreateEx(5, 95, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Cluster Size:");
	handles.msc.hClusterSize = TEXT_CreateEx(80, 95, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "16k");

	// LOG
	TEXT_CreateEx(5, 125, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Logfile:");
	handles.log.hFilename = TEXT_CreateEx(80, 125, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "N/A");

	TEXT_CreateEx(5, 140, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Filesize:");
	handles.log.hSize = TEXT_CreateEx(80, 140, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "0");

	TEXT_CreateEx(5, 155, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Data In:");
	handles.log.hBytesIn = TEXT_CreateEx(80, 155, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "0");

	TEXT_CreateEx(5, 170, 70, 15, handles.desktop, WM_CF_SHOW, 0, 0, "Write Speed:");
	handles.log.hBytesOut = TEXT_CreateEx(80, 170, 160, 15, handles.desktop, WM_CF_SHOW, 0, 0, "0");

	WM_HWIN hClose = BUTTON_CreateEx(5, 190, 230, 30, handles.desktop, WM_CF_SHOW, 0, GUI_ID_BGCOM);
	BUTTON_SetText(hClose, "Close Logfile");
	BUTTON_SetFont(hClose, &GUI_Font20B_ASCII);
//	BUTTON_SetTextColor(hDis, BUTTON_CI_PRESSED, GUI_RED);
//	BUTTON_SetTextColor(hDis, BUTTON_CI_UNPRESSED, GUI_RED);
//	BUTTON_SetBkColor(hDis, BUTTON_CI_PRESSED, GUI_DARKRED);
//	BUTTON_SetBkColor(hDis, BUTTON_CI_UNPRESSED, GUI_GRAY);

	return handles.desktop;
}

void BGComHCDUpdate(USBHCDConnectionEvent* pConEvent)
{
	char buf[16];

	snprintf(buf, 16, "%hu", (uint16_t)pConEvent->classCode);
	TEXT_SetText(handles.hcd.hClassCode, buf);

	TEXT_SetText(handles.hcd.hClass, pConEvent->pName);
	TEXT_SetText(handles.hcd.hManufacturer, pConEvent->pManufacturer);
	TEXT_SetText(handles.hcd.hProduct, pConEvent->pProduct);
	TEXT_SetText(handles.hcd.hSerial, pConEvent->pSerialNumber);
}

void BGComMSCUpdate(USBMSCEvent* pEvent)
{
	char buf[16];

	snprintf(buf, 16, "%u MB", pEvent->fatSize);
	TEXT_SetText(handles.msc.hFatSize, buf);

	snprintf(buf, 16, "%u MB", pEvent->freeSize);
	TEXT_SetText(handles.msc.hFreeSize, buf);

	snprintf(buf, 16, "%u kB", pEvent->clusterSize);
	TEXT_SetText(handles.msc.hClusterSize, buf);

}

void BGComLogUpdate(LogFileEvent* pLogEvent)
{
	char buf[16];

	TEXT_SetText(handles.log.hFilename, pLogEvent->pFilename);

	if(pLogEvent->fileSize < 1024*1024*10)
		snprintf(buf, 16, "%u kB", pLogEvent->fileSize/1024);
	else
		snprintf(buf, 16, "%u MB", pLogEvent->fileSize/(1024*1024));

	TEXT_SetText(handles.log.hSize, buf);

	snprintf(buf, 16, "%u kB/s", pLogEvent->bytesPerSecIn/1024);
	TEXT_SetText(handles.log.hBytesIn, buf);

	snprintf(buf, 16, "%u kB/s", pLogEvent->writeSpeed/1024);
	TEXT_SetText(handles.log.hBytesOut, buf);
}
