/*
 * botcover.c
 *
 *  Created on: 02.07.2014
 *      Author: ryll
 */

#include "botcover.h"

#include "DIALOG.h"

static const char botCovers[12][4] = {
		{'m', 'm', 'g', 'm'},
		{'g', 'm', 'g', 'm'},
		{'g', 'g', 'g', 'm'},
		{'m', 'g', 'g', 'm'},
		{'m', 'm', 'm', 'g'},
		{'g', 'm', 'm', 'g'},
		{'g', 'g', 'm', 'g'},
		{'m', 'g', 'm', 'g'},
		{'g', 'g', 'g', 'g'},
		{'m', 'm', 'm', 'm'},
		{'m', 'm', 'g', 'g'},
		{'g', 'g', 'm', 'm'},
};

static void drawBotCover(uint8_t id)
{
	uint8_t blue = 0;

	if(id > 23)
		return;

	GUI_SetColor(GUI_BLACK);
	GUI_FillCircle(30, 29, 29);

	GUI_SetColor(GUI_GRAY);
	GUI_DrawCircle(30, 29, 29);
	GUI_DrawHLine(49, 8, 52);

	if(id >= 12)
	{
		id -= 12;
		blue = 1;
		GUI_SetColor(GUI_BLUE);
	}
	else
	{
		GUI_SetColor(GUI_YELLOW);
	}

	GUI_SetBkColor(GUI_BLACK);

	GUI_FillCircle(30, 29, 10);

	const char* pCover = botCovers[id];

	if(pCover[0] == 'm')
		GUI_SetColor(GUI_MAGENTA);
	else
		GUI_SetColor(GUI_GREEN);

	// lower right
	GUI_FillCircle(48, 41, 7);

	if(pCover[1] == 'm')
		GUI_SetColor(GUI_MAGENTA);
	else
		GUI_SetColor(GUI_GREEN);

	// lower left
	GUI_FillCircle(12, 41, 7);

	if(pCover[2] == 'm')
		GUI_SetColor(GUI_MAGENTA);
	else
		GUI_SetColor(GUI_GREEN);

	// upper right
	GUI_FillCircle(42, 11, 7);

	if(pCover[3] == 'm')
		GUI_SetColor(GUI_MAGENTA);
	else
		GUI_SetColor(GUI_GREEN);

	// upper left
	GUI_FillCircle(18, 11, 7);

	if(blue)
	{
		GUI_SetColor(GUI_WHITE);
		GUI_SetBkColor(GUI_BLUE);
	}
	else
	{
		GUI_SetColor(GUI_BLACK);
		GUI_SetBkColor(GUI_YELLOW);
	}

	GUI_SetFont(&GUI_Font13B_ASCII);
	GUI_GotoXY(24, 23);
	GUI_DispDecSpace(id, 2);
}

static void winCallback(WM_MESSAGE* pMsg)
{
	switch(pMsg->MsgId)
	{
	case WM_PAINT:
	{
		uint8_t botId = 0;
		WINDOW_GetUserData(pMsg->hWin, &botId, 1);

		drawBotCover(botId);
	}
	break;
	default:
		BUTTON_Callback(pMsg);
	}
}

WM_HWIN BOTCOVER_CreateEx(int x0, int y0, WM_HWIN hParent, int WinFlags, int ID, uint8_t botId)
{
	WM_HWIN hBtn = BUTTON_CreateUser(x0, y0, 60, 50, hParent, WinFlags | WM_CF_HASTRANS, 0, ID, 1);
	WM_SetCallback(hBtn, &winCallback);
	WINDOW_SetUserData(hBtn, &botId, 1);

	return hBtn;
}

void BOTCOVER_SetId(WM_HWIN hWin, uint8_t botId)
{
	WINDOW_SetUserData(hWin, &botId, 1);
	WM_InvalidateWindow(hWin);
}
