/*
 * exti.c
 *
 *  Created on: 29.05.2010
 *      Author: AndreR
 */

#include "exti.h"

#include "../constants.h"
#include "util/init_hal.h"
#include "ch.h"

Exti exti;

void EXTI9_5_IRQHandler()
{
	CH_IRQ_PROLOGUE();

	for(uint8_t i = 5; i <= 9; i++)
	{
		if(EXTI->PR & (1 << i))
		{
			if(exti.callbacks[i])
				(*exti.callbacks[i])();

			EXTI->PR = (1 << i);
		}
	}

	CH_IRQ_EPILOGUE();
}

void EXTI15_10_IRQHandler()
{
	CH_IRQ_PROLOGUE();

	for(uint8_t i = 10; i <= 15; i++)
	{
		if(EXTI->PR & (1 << i))
		{
			if(exti.callbacks[i])
				(*exti.callbacks[i])();

			EXTI->PR = (1 << i);
		}
	}

	CH_IRQ_EPILOGUE();
}

void ExtiInit()
{
	for(uint8_t i = 0; i < 16; i++)
		exti.callbacks[i] = 0;

	NVICEnableIRQ(EXTI9_5_IRQn, IRQL_EXTI5_9);
	NVICEnableIRQ(EXTI15_10_IRQn, IRQL_EXTI10_15);
}

void ExtiSetCallback(ExtiCallback cb, uint8_t channel)
{
	exti.callbacks[channel] = cb;
}
