/*
 * fsmc.c
 *
 *  Created on: 16.01.2013
 *      Author: AndreR
 */

#include "util/init_hal.h"

void FSMCInit()
{
	GPIOInitData gpioInit;

	/* Enable FSMC clock */
	RCC->AHB3ENR |= RCC_AHB3ENR_FSMCEN;

	/*-- GPIOs Configuration -----------------------------------------------------*/
	/*
	 +-------------------+--------------------+------------------+------------------+
	 | PD0  <-> FSMC_D2  | PE0  <-> FSMC_NBL0 | PF0 <-> FSMC_A0  | PG0 <-> FSMC_A10 |
	 | PD1  <-> FSMC_D3  | PE1  <-> FSMC_NBL1 | PF1 <-> FSMC_A1  | PG1 <-> FSMC_A11 |
	 | PD4  <-> FSMC_NOE | PE3  <-> FSMC_A19  | PF2 <-> FSMC_A2  | PG2 <-> FSMC_A12 |
	 | PD5  <-> FSMC_NWE | PE7  <-> FSMC_D4   | PF3 <-> FSMC_A3  | PG3 <-> FSMC_A13 |
	 | PD7  <-> FSMC_NE1 | PE8  <-> FSMC_D5   | PF3 <-> FSMC_A3  | PG3 <-> FSMC_A13 |
	 | PD8  <-> FSMC_D13 | PE9  <-> FSMC_D6   | PF4 <-> FSMC_A4  | PG4 <-> FSMC_A14 |
	 | PD9  <-> FSMC_D14 | PE10 <-> FSMC_D7   | PF5 <-> FSMC_A5  | PG5 <-> FSMC_A15 |
	 | PD10 <-> FSMC_D15 | PE11 <-> FSMC_D8   | PF12 <-> FSMC_A6 | PG9 <-> FSMC_NE2 |
	 | PD11 <-> FSMC_A16 | PE12 <-> FSMC_D9   | PF13 <-> FSMC_A7 |------------------+
	 | PD12 <-> FSMC_A17 | PE13 <-> FSMC_D10  | PF14 <-> FSMC_A8 |
	 | PD13 <-> FSMC_A18 | PE14 <-> FSMC_D11  | PF15 <-> FSMC_A9 |
	 | PD14 <-> FSMC_D0  | PE15 <-> FSMC_D12  |------------------+
	 | PD15 <-> FSMC_D1  +--------------------+
	 +-------------------+
	 */

	gpioInit.mode = GPIO_MODE_AF;
	gpioInit.alternate = 0x0C;
	gpioInit.otype = GPIO_OTYPE_PUSH_PULL;
	gpioInit.ospeed = GPIO_OSPEED_F4_100MHZ;
	gpioInit.pupd = GPIO_PUPD_NONE;

	GPIOInit(GPIOD, GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_4
			| GPIO_PIN_5 | GPIO_PIN_7 | GPIO_PIN_8 | GPIO_PIN_9 | GPIO_PIN_10 | GPIO_PIN_11
			| GPIO_PIN_12 | GPIO_PIN_13 | GPIO_PIN_14 | GPIO_PIN_15, &gpioInit);

	GPIOInit(GPIOE, GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_3 | GPIO_PIN_7
			| GPIO_PIN_8 | GPIO_PIN_9 | GPIO_PIN_10 | GPIO_PIN_11 | GPIO_PIN_12
			| GPIO_PIN_13 | GPIO_PIN_14 | GPIO_PIN_15, &gpioInit);

	GPIOInit(GPIOF, GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2
			| GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5 | GPIO_PIN_12 | GPIO_PIN_13
			| GPIO_PIN_14 | GPIO_PIN_15, &gpioInit);

	GPIOInit(GPIOG,  GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2
			| GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5 | GPIO_PIN_9, &gpioInit);
}
