/*
 * ov7725.h
 *
 *  Created on: 02.12.2012
 *      Author: AndreR
 */

#ifndef OV7725_H_
#define OV7725_H_

#include "util/sccb.h"

#include "ch.h"

// OV7725 register definitions
#define OV7725_GAIN		0x00
#define OV7725_BLUE		0x01
#define OV7725_RED		0x02
#define OV7725_GREEN	0x03
#define OV7725_AECH		0x08
#define OV7725_COM2		0x09
#define OV7725_PID		0x0A
#define OV7725_VER		0x0B
#define OV7725_COM3		0x0C
#define OV7725_COM4		0x0D
#define OV7725_COM5		0x0E
#define OV7725_COM6		0x0F
#define OV7725_AEC		0x10
#define OV7725_CLKRC	0x11
#define OV7725_COM7		0x12
#define OV7725_COM8		0x13
#define OV7725_COM9		0x14
#define OV7725_COM10	0x15
#define OV7725_HSTART	0x17
#define OV7725_HSIZE	0x18
#define OV7725_VSTART	0x19
#define OV7725_VSIZE	0x1A
#define OV7725_PSHIFT	0x1B
#define OV7725_MIDH		0x1C
#define OV7725_MIDL		0x1D
#define OV7725_LAEC		0x1F
#define OV7725_COM11	0x20
#define OV7725_BDBASE	0x22
#define OV7725_BDMSTEP	0x23
#define OV7725_AEW		0x24
#define OV7725_AEB		0x25
#define OV7725_VPT		0x26
#define OV7725_HOUTSIZE	0x29
#define OV7725_EXHCH	0x2A
#define OV7725_EXHCL	0x2B
#define OV7725_VOUTSIZE	0x2C
#define OV7725_ADVFL	0x2D
#define OV7725_ADVFH	0x2E
#define OV7725_YAVE		0x2F
#define OV7725_LUMHTH	0x30
#define OV7725_LUMLTH	0x31
#define OV7725_HREF		0x32
#define OV7725_DMLNL	0x33
#define OV7725_DMLNH	0x34
#define OV7725_COM12	0x3D
#define OV7725_COM13	0x3E
#define OV7725_COM14	0x3F
#define OV7725_COM15	0x40
#define OV7725_COM16	0x41
#define OV7725_AWBBBLK	0x62
#define OV7725_AWBCTRL0	0x63
#define OV7725_DSPCTRL1	0x64
#define OV7725_DSPCTRL2	0x65
#define OV7725_DSPCTRL3	0x66
#define OV7725_DSPCTRL4	0x67
#define OV7725_AWBBIAS	0x68
#define OV7725_AWBCTRL1	0x69
#define OV7725_AWBCTRL2	0x6A
#define OV7725_AWBCTRL3	0x6B
#define OV7725_EDGE0	0x8F
#define OV7725_EDGE1	0x90
#define OV7725_EDGE2	0x92
#define OV7725_EDGE3	0x93
#define OV7725_BRIGHT	0x9B
#define OV7725_CNST		0x9C
#define OV7725_SDE		0xA6
#define OV7725_SIGN		0xAB
#define OV7725_DSPAUTO	0xAC

#define OV7725_MODE_SNAPSHOT			0
#define OV7725_MODE_STREAM_TO_DISPLAY 	1

typedef struct _OV7725
{
	SCCB sccb;

	BinarySemaphore acqDoneSem;

	uint8_t mode;
} OV7725;

extern OV7725 ov7725;

void		OV7725Init();
int16_t		OV7725WriteReg(uint16_t addr, uint8_t data);
int16_t		OV7725ReadReg(uint16_t addr, uint8_t* pData);
int16_t		OV7725AcquireImage();
uint8_t*	OV7725GetPicBuf();
void		OV7725SetMode(uint8_t mode);

#endif /* OV7725_H_ */
