/*
 * sram.c
 *
 *  Created on: 01.12.2012
 *      Author: AndreR
 */

#include "sram.h"

#include "util/init_hal.h"

void SRAMInit()
{
	// DataWidth = 16Bit, Write enable
	FSMC_Bank1->BTCR[2] = FSMC_BCR1_MWID_0 | FSMC_BCR1_WREN;

	// AccessMode A, BusTurnAround = 1, DataSetupTime = 2, AddressSetupTime = 2
	FSMC_Bank1->BTCR[3] = (1 << 16) | (2 << 8) | 2;

	FSMC_Bank1->BTCR[2] |= FSMC_BCR1_MBKEN;
}

void SRAMWriteBuffer(uint16_t* pBuffer, uint32_t WriteAddr, uint32_t NumHalfwordToWrite)
{
	for (; NumHalfwordToWrite != 0; NumHalfwordToWrite--) /* while there is data to write */
	{
		/* Transfer data to the memory */
		*(uint16_t *) (EXT_SRAM_ADDR + WriteAddr) = *pBuffer++;

		/* Increment the address*/
		WriteAddr += 2;
	}
}

void SRAMReadBuffer(uint16_t* pBuffer, uint32_t ReadAddr, uint32_t NumHalfwordToRead)
{
	for (; NumHalfwordToRead != 0; NumHalfwordToRead--) /* while there is data to read */
	{
		/* Read a half-word from the memory */
		*pBuffer++ = *(__IO uint16_t*) (EXT_SRAM_ADDR + ReadAddr);

		/* Increment the address*/
		ReadAddr += 2;
	}
}
