/*
 * tft.h
 *
 *  Created on: 04.12.2012
 *      Author: AndreR
 */

#ifndef TFT_H_
#define TFT_H_

#include <stdint.h>

#define TFT_CMD_REG ((volatile uint16_t*)0x60000000)
#define TFT_DATA_REG ((volatile uint16_t*)0x60100000)

// convert 0x00RRGGBB to RGB565 format, max value for R, G and B is 0x3F (6Bit)
#define TFT_COLOR(rgb) ((uint16_t)((rgb & 0x3E0000) >> 6) | (rgb & 0x3F00) >> 3 | (rgb & 0x3E) >> 1)

// Register Definitions
#define TFT_REG_SOFT_RESET					0x01
#define TFT_REG_SET_DISPLAY_ON				0x29
#define TFT_REG_SET_COLUMN_ADDRESS			0x2A
#define TFT_REG_SET_PAGE_ADDRESS			0x2B
#define TFT_REG_WRITE_MEMORY_START			0x2C
#define TFT_REG_SET_ADDRESS_MODE			0x36
#define TFT_REG_EXIT_IDLE_MODE				0x38
#define TFT_REG_WRITE_MEMORY_CONTINUE		0x3C
#define TFT_REG_SET_LCD_MODE				0xB0
#define TFT_REG_SET_HORI_PERIOD				0xB4
#define TFT_REG_SET_VERT_PERIOD				0xB6
#define TFT_REG_SET_GPIO_CONF				0xB8
#define TFT_REG_SET_GPIO_VALUE				0xBA
#define TFT_REG_SET_PWM_CONF				0xBE
#define TFT_REG_SET_PLL						0xE0
#define TFT_REG_SET_PLL_MN					0xE2
#define TFT_REG_SET_LSHIFT_FREQ				0xE6
#define TFT_REG_SET_PIXEL_DATA_INTERFACE	0xF0
#define TFT_REG_SET_ADDR_MODE				0x36
#define TFT_REG_SET_COL_ADDR				0x2A
#define TFT_REG_SET_PG_ADDR					0x2B

void TFTInit();
void TFTSetBrightness(uint8_t level);
void TFTWritePixel(uint32_t color);

#endif /* TFT_H_ */
