/*
 * touch.h
 *
 *  Created on: 07.05.2014
 *      Author: AndreR
 */

#ifndef __TOUCH_H__
#define __TOUCH_H__

#include "ch.h"
#include "util/spi_sync.h"

#define TOUCH_DATA_BUF_SIZE 18

typedef struct _TouchSwipeEvent
{
	int16_t downPos[2];
	uint32_t downTime;
	int16_t upPos[2];
	uint32_t upTime;

	int16_t move[2];	// positive means right/down, negative left/up
	uint16_t length;
	uint32_t deltaT;
} TouchSwipeEvent;

typedef void(*TouchSwipeCb)(TouchSwipeEvent*);

typedef struct _Touch
{
	BinarySemaphore touchedSem;
	SPISync spi3;
	uint8_t buf[TOUCH_DATA_BUF_SIZE];

	volatile uint8_t touchPressed;		// clear after reading 1
	volatile uint8_t touchReleased;		// clear after reading 1
	volatile uint8_t touchDown;	// read only by user, indicates valid X and Y

	uint16_t touchX;
	uint16_t touchY;
	uint16_t touchZ1;
	uint16_t touchZ2;
	float touchZ;

	TouchSwipeEvent swipe;
	TouchSwipeCb swipeCb;
} Touch;

extern Touch touch;

void	TouchInit();
msg_t	TouchTask(void* params);

#endif
