/*
 * intercom.c
 *
 *  Created on: 18.11.2012
 *      Author: AndreR
 */

#include "intercom1.h"

#include "util/intercom.h"

#include "hal/usart2.h"
#include "constants.h"
#include "intercom_constants.h"

static void txReady(void* pData)
{
	USART* pUSART = (USART*)pData;
	USARTStartTransfer(pUSART);
}

void Intercom1Init()
{
	IntercomMedium medium;
	medium.pRxFifo = &usart2.rxFifo;
	medium.pTxFifo = &usart2.txFifo;
	medium.txReady = &txReady;
	medium.pTxReadyData = &usart2;
	medium.reachableAddresses = INTERCOM_ADDRESS_MAIN | INTERCOM_ADDRESS_LEFT | INTERCOM_ADDRESS_RIGHT | INTERCOM_ADDRESS_KD;

	usart2.callback = &IntercomRxReady;
	usart2.pUserData = 0;

	IntercomInit(INTERCOM_ADDRESS_MEDIA, 0);
	IntercomAddMedium(medium);
}
