/*
 * intercom.c
 *
 *  Created on: 18.11.2012
 *      Author: AndreR
 */

#include "intercom1.h"

#include "util/intercom.h"
#include "intercom_constants.h"
#include "spi1.h"


void Intercom1Init()
{
	IntercomMedium medium;
	medium.pRxFifo = &spi1.rxFifo;
	medium.pTxFifo = &spi1.txFifo;
	medium.txReady = &SPI1TxReady;
	medium.pTxReadyData = 0;
	medium.reachableAddresses = INTERCOM_ADDRESS_MAIN | INTERCOM_ADDRESS_KD | INTERCOM_ADDRESS_MEDIA;

#ifdef MOT_LEFT
	IntercomInit(INTERCOM_ADDRESS_LEFT, 0);
	medium.reachableAddresses |= INTERCOM_ADDRESS_RIGHT;
#else
	IntercomInit(INTERCOM_ADDRESS_RIGHT, 0);
	medium.reachableAddresses |= INTERCOM_ADDRESS_LEFT;
#endif

	spi1.callback = &IntercomRxReady;
	spi1.pCbData = 0;
	IntercomAddMedium(medium);
}
