/*
 * cpu_load.c
 *
 *  Created on: 13.05.2014
 *      Author: AndreR
 */

#include "cpu_load.h"
#include "util/sys_time.h"
#include "ch.h"

#pragma GCC optimize ("Os")

#define SYSTICK_T_IN_US (1000000/CH_FREQUENCY)

CPULoad cpuLoad;

void CPULoadCalibrate(uint8_t ticks)
{
	cpuLoad.calibrate = ticks;
	cpuLoad.maxIncPerSysTick = 0;
}

void CPULoadSysTickHook()
{
	uint32_t dCnt = cpuLoad.counter - cpuLoad.cntLastEval;
	cpuLoad.cntLastEval = cpuLoad.counter;

	uint32_t dT = SysTimeUSec() - cpuLoad.timeLastEval;
	cpuLoad.timeLastEval = SysTimeUSec();

	cpuLoad.incPerSysTick = (dCnt*SYSTICK_T_IN_US)/dT;
//	cpuLoad.incPerSysTick = dCnt;
	if(cpuLoad.calibrate)
	{
		if(cpuLoad.maxIncPerSysTick < cpuLoad.incPerSysTick)
			cpuLoad.maxIncPerSysTick = cpuLoad.incPerSysTick;

		--cpuLoad.calibrate;
		if(cpuLoad.calibrate == 0)
		{
			cpuLoad.maxIncPerSysTick += 10;
			cpuLoad.maxLoad = 0;
		}
	}

	if(cpuLoad.maxIncPerSysTick)
	{
		if(cpuLoad.incPerSysTick > cpuLoad.maxIncPerSysTick)
			cpuLoad.load = (cpuLoad.incPerSysTick*1000)/cpuLoad.maxIncPerSysTick;
		else
			cpuLoad.load = ((cpuLoad.maxIncPerSysTick-cpuLoad.incPerSysTick)*1000)/cpuLoad.maxIncPerSysTick;

		if(cpuLoad.load > cpuLoad.maxLoad)
			cpuLoad.maxLoad = cpuLoad.load;
	}
}
