/*
 * cpu_load.h
 *
 *  Created on: 13.05.2014
 *      Author: AndreR
 */

#ifndef CPU_LOAD_H_
#define CPU_LOAD_H_

#include <stdint.h>

typedef struct _CPULoad
{
	uint32_t timeLastEval;
	uint32_t cntLastEval;
	volatile uint32_t counter;
	uint32_t incPerSysTick;
	uint32_t load;	// 1000 steps [0.0% - 100.0%]
	uint32_t maxLoad;

	uint32_t maxIncPerSysTick;	// denotes 0% load
	uint8_t calibrate;
} CPULoad;

extern CPULoad cpuLoad;

void CPULoadCalibrate(uint8_t ticks);
void CPULoadSysTickHook();

#endif /* CPU_LOAD_H_ */
