/*
 * hw_sync.c
 *
 *  Created on: 16.12.2012
 *      Author: AndreR
 */

#include "hw_sync.h"
#include "util/init_hal.h"
#include "ch.h"

void HWSyncInit(HWSync* pSync, GPIO_TypeDef* pPort, uint32_t pin)
{
	pSync->pPort = pPort;
	pSync->pin = pin;

	for(uint32_t i = 0; i < 16; i++)
	{
		if(pin & (1 << i))
		{
			pSync->pinNumber = i;
			break;
		}
	}

	GPIOInitData gpioInit;
	gpioInit.mode = GPIO_MODE_OUTPUT;
	gpioInit.otype = GPIO_OTYPE_OPEN_DRAIN;
	gpioInit.ospeed = GPIO_OSPEED_F4_2MHZ;
	gpioInit.pupd = GPIO_PUPD_UP;
	GPIOInit(pPort, pin, &gpioInit);

	pPort->BSRRH = pin;
}

void HWSyncBarrier(HWSync* pSync)
{
	// make pin input
	pSync->pPort->MODER &= ~(3 << pSync->pinNumber*2);

	while(42)
	{
		if(pSync->pPort->IDR & pSync->pin)
			break;

		chThdSleepMilliseconds(1);
	}

	chThdSleepMilliseconds(10);

	// and output again
	pSync->pPort->MODER |= (1 << pSync->pinNumber*2);
}
