/*
 * sccb.h
 *
 *  Created on: 03.12.2012
 *      Author: AndreR
 *
 *	Serial Camera Control Bus (SCCB) bit banging interface.
 *	Uses GPIOs to talk to cameras.
 */

#ifndef SCCB_H_
#define SCCB_H_

#include "stm32f407xx.h"

typedef struct _SCCB
{
	GPIO_TypeDef* pPort;
	uint32_t clkPin;
	uint32_t dataPin;
	uint8_t address;
} SCCB;

void	SCCBInit(SCCB* pSCCB, GPIO_TypeDef* pPort, uint32_t clkPin, uint32_t dataPin, uint8_t address);
int16_t	SCCBWriteReg(SCCB* pSCCB, uint8_t regID, uint8_t regDat);
int16_t SCCBReadReg(SCCB* pSCCB, uint8_t regID, uint8_t *regDat);

#endif /* SCCB_H_ */
