/*
 * arm_mat_util_f32.h
 *
 *  Created on: 23.12.2014
 *      Author: AndreR
 */

#include "arm_math.h"

#define MAT_ELEMENT(mat,r,c) ((mat).pData[(mat).numCols*(r)+(c)])

void arm_mat_zero_f32(arm_matrix_instance_f32* pMat);
arm_status arm_mat_identity_f32(arm_matrix_instance_f32* pMat);
void arm_mat_copy_f32(arm_matrix_instance_f32* pSrc, arm_matrix_instance_f32* pDst);
void arm_mat_clip_f32(arm_matrix_instance_f32* pMat, float min, float max);
void arm_mat_fill_f32(arm_matrix_instance_f32* pMat, float value);
void arm_mat_print(const arm_matrix_instance_f32* pMat);
float* arm_mat_row_ptr(const arm_matrix_instance_f32* pMat, uint16_t row);
arm_status arm_mat_pinv(const arm_matrix_instance_f32* A, arm_matrix_instance_f32* B);
arm_status arm_mat_svd(arm_matrix_instance_f32* U, arm_matrix_instance_f32* S, arm_matrix_instance_f32* V);
arm_status arm_mat_chol(const arm_matrix_instance_f32* A, arm_matrix_instance_f32* L);
arm_status arm_mat_pds_inv(arm_matrix_instance_f32* A, arm_matrix_instance_f32* B);
arm_status arm_mat_inv_2x2_f32(const arm_matrix_instance_f32* A, arm_matrix_instance_f32* B);
arm_status arm_mat_inv_3x3_f32(const arm_matrix_instance_f32* A, arm_matrix_instance_f32* B);

float32_t arm_atan2_f32(float32_t y, float32_t x);
