/*
 * boot.h
 *
 *  Created on: 21.04.2013
 *      Author: AndreR
 */

#ifndef BOOT_H_
#define BOOT_H_

#include <stdint.h>

#ifdef STM32F30X
#define BOOT_APP_OFFSET 0x08800
#define BOOT_APP_END 0x0801F800
#else
#define BOOT_APP_OFFSET 0x20000
#define BOOT_APP_END 0x08060000
#endif

#define BOOT_APP_ADDR (0x08000000 + BOOT_APP_OFFSET)

uint32_t BootIsBootloaderSelected();
void BootSetBootloaderSelected(uint8_t enable);
uint32_t BootGetBootCode();
void BootJumpToApplication();
void BootReset();

int16_t BootProgramFlash(uint32_t* pData, uint32_t length, uint32_t offset);
int16_t BootEraseProgramFlash();

#endif /* BOOT_H_ */
