/*
 * crc.h
 *
 *  Created on: 06.06.2013
 *      Author: AndreR
 */

#ifndef CRC_H_
#define CRC_H_

#include <stdint.h>

#define CRC32_MAGIC_NUMBER 0x2144DF1C	// result of CRC verification must be this value

void CRCInit();
uint32_t CRC32Checksum(uint32_t* pData, uint32_t dataLength);

void CRC32StartChecksum();
void CRC32FeedChecksum(uint8_t* pData, uint32_t dataLength);
uint32_t CRC32StopChecksum();

uint32_t CRC32CalcChecksum(uint8_t* pData, uint32_t dataLength);
uint32_t CRC32VerifyChecksum(uint8_t* pData, uint32_t dataLength, uint32_t crc);

uint32_t CRC32StartChecksumAlt();
uint32_t CRC32FeedChecksumAlt(uint32_t crc, uint8_t* pData, uint32_t dataLength);
uint32_t CRC32StopChecksumAlt(uint32_t crc);

uint32_t CRC32CalcChecksumAlt(uint8_t* pData, uint32_t dataLength);
uint32_t CRC32VerifyChecksumAlt(uint8_t* pData, uint32_t dataLength, uint32_t crc);

#endif /* CRC_H_ */
