/*
 * intercom_reliable.h
 *
 *  Created on: 30.03.2015
 *      Author: AndreR
 */

#ifndef INTERCOM_RELIABLE_H_
#define INTERCOM_RELIABLE_H_

#include "ch.h"
#include "util/intercom.h"
#include "intercom_constants.h"

#define INTERCOM_RELIABLE_DATA_SIZE 512
#define INTERCOM_RELIABLE_TIMEOUT	10 // [ms]

typedef struct _IntercomReliable
{
	uint8_t procBuf[INTERCOM_RELIABLE_DATA_SIZE];

	Mutex sendMtx;
	uint16_t seq;

	uint16_t lastRxSeq[INTERCOM_MAX_ADDRESSES];

	BinarySemaphore ackSem;
	volatile uint8_t sendAddrMask;
} IntercomReliable;

extern IntercomReliable intercomReliable;

void IntercomReliableInit();
int16_t IntercomReliableSend(const IntercomHeader* pHeader, uint16_t dataLength, void* _pData);

#endif /* INTERCOM_RELIABLE_H_ */
