/*
 * network_print.h
 *
 *  Created on: 23.10.2014
 *      Author: AndreR
 */

#ifndef NETWORK_PRINT_H_
#define NETWORK_PRINT_H_

#include "ch.h"
#include "intercom.h"

#define NETWORK_PRINT_SIZE 100

typedef void(*NetworkPrintOutputFunc)(void* pBuf, uint16_t dataLength);

typedef struct _NetworkPrint
{
	uint8_t netPrint[NETWORK_PRINT_SIZE];
	char* pPrintPos;
	uint16_t printSize;
	Mutex printMutex;
	NetworkPrintOutputFunc pOutFunc;
} NetworkPrintData;

extern NetworkPrintData networkPrint;

void NetworkPrintInit(NetworkPrintOutputFunc pOutFunc, uint8_t source);
int32_t NetworkPrint(const char* fmt, ...);

void NetworkPrintInitIntercom();

#endif /* NETWORK_PRINT_H_ */
