/*
 * sys_time.h
 *
 *  Created on: 09.04.2014
 *      Author: AndreR
 */

#ifndef SYS_TIME_H_
#define SYS_TIME_H_

#include "ch.h"
#include "intercom.h"

typedef struct _SysTime
{
	float correction;
	int32_t comOffset;
	uint32_t lastCorrTime;
} SysTimeGlobal;

extern SysTimeGlobal sysTime;

void SysTimeInitCorrection(int32_t transmissionTime);

// microsecond precision, integer arithmetic => fast + recommended
unsigned long SysTimeUSec();
unsigned long SysTimeUSecRaw();	// not synchronized

// converts SysTimeUSec to seconds (float)
float SysTime();

// maximum precision, uses floating point arithmetic => slow
float SysTimePrec();

#endif /* SYS_TIME_H_ */
