/*
 * terminal.h
 *
 *  Created on: 26.10.2014
 *      Author: AndreR
 */

#ifndef TERMINAL_H_
#define TERMINAL_H_

#include "ch.h"

#define TERMINAL_INPUT_BUFFER_SIZE 80

typedef struct _VT100Result
{
	uint16_t code;
	uint16_t param1;
	uint16_t param2;
} VT100Result;

enum VT100Sequence
{
	CURSOR_UP = 1,
	CURSOR_DOWN,
	CURSOR_FORWARD,
	CURSOR_BACKWARD,
	FUNCTION_KEY,
};

enum VT100FunctionKeys
{
	FK_HOME = 1,
	FK_INSERT,
	FK_DELETE,
	FK_END,
	FK_PAGE_UP,
	FK_PAGE_DOWN,
	FK_F1 = 11,
	FK_F2,
	FK_F3,
	FK_F4,
	FK_F5,
	FK_F6 = 17,
	FK_F7,
	FK_F8,
	FK_F9,
	FK_F10,
	FK_F11 = 23,
	FK_F12,
};

typedef void(*TerminalCmdCb)(char*, uint16_t);
typedef void(*TerminalEscCb)(VT100Result*);

typedef struct _Terminal
{
	char inputBuffer[TERMINAL_INPUT_BUFFER_SIZE];
	uint16_t inBufPos;

	TerminalCmdCb cmdCb;
	TerminalEscCb escCb;

	InputQueue* pInQueue;
	OutputQueue* pOutQueue;
} Terminal;

extern Terminal terminal;

void	TerminalInit(InputQueue* pInQueue, OutputQueue* pOutQueue);
msg_t	TerminalTask(void* params);
void	TerminalWrite(uint8_t* pData, uint32_t dataLength);

#endif /* TERMINAL_H_ */
